using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.Product.Cqrs;

public record DeleteProductByIdRequest(string Id);

public record DeleteProductByIdCommand(DeleteProductByIdRequest Data) : IRequest<bool>;

public class DeleteProductByIdHandler : IRequestHandler<DeleteProductByIdCommand, bool>
{
    private readonly AppDbContext _context;

    public DeleteProductByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteProductByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.Product
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null) return false;

        _context.Product.Remove(entity);
        return await _context.SaveChangesAsync(cancellationToken) > 0;
    }
}